function MCMC = mcmc(c0,c1,gammahat,indx,N,Sigma,theta,W,xmode)

% Initial draw for RWMH
[L,D] = ldl(Sigma);
d = diag(D);
d(d<sqrt(eps)) = sqrt(eps);
D = diag(d);
P = L*sqrt(abs(D));
x0 = xmode+c0*randn(size(xmode))*P';
L0 = -cmd(x0,gammahat,indx,theta,W);
    
% RWMH algorithm

MCMC   = zeros(floor(0.5*N),length(x0)+1);
u      = rand(N,1);
z      = c1*randn(N,length(x0))*P';
for j=1:N  
    try
        x1 = x0+z(j,:);
    	L1 = -cmd(x1,gammahat,indx,theta,W);
    catch
        continue 
    end
    if u(j,1) < exp(L1-L0)
        x0     = x1;  
        L0     = L1;
    end
    if j>0.5*N
        MCMC(j-floor(0.5*N),:) = [L0 x0];
    end
end

