function ml = mdd(gammahat,indx,MCMC,theta,W)
d     = size(MCMC,2)-1;
chi25 = chi2inv(0.5,d);
chi29 = chi2inv(0.9,d);
HM5   = 0;
HM9   = 0;
N     = size(MCMC,1);
num   = 0;
r     = zeros(N,1);
SWZ5  = 0;
SWZ9  = 0;
tauhat5 = 0;
tauhat9 = 0;

xmean    = mean(MCMC(:,2:end));
qmean    = -cmd(xmean,gammahat,indx,theta,W);
Sigmahat = cov(MCMC(:,2:end));
[L,D]=ldl(Sigmahat);
D = diag(D);
D(D<sqrt(eps))=sqrt(eps);
Sigmahat = L*diag(D)*L';
for j=1:N
    L0 = MCMC(j,1);
    x0 = MCMC(j,2:end);
    r(j,1) = (x0-xmean)*inv(Sigmahat)*(x0-xmean)';
end
% Harmonic mean estimators
indx5 = (r<chi25);
indx9 = (r<chi29);
HM5 = sum(exp(-0.5*r(indx5,1)-MCMC(indx5,1)))/N;
HM9 = sum(exp(-0.5*r(indx9,1)-MCMC(indx9,1)))/N;
HM5 = log(0.5)-log(HM5)+(d/2)*log(2*pi)+(1/2)*log(det(Sigmahat));
HM9 = log(0.9)-log(HM9)+(d/2)*log(2*pi)+(1/2)*log(det(Sigmahat));
% The Chib-Jeliazkov estimator
[qmode,i] = max(MCMC(:,1));
xmode     = MCMC(i,2:end);
Sigmatilde = (MCMC(:,2:end)-ones(N,1)*xmode)'*(MCMC(:,2:end)-ones(N,1)*xmode)/N;
[L,D]=ldl(Sigmatilde);
D = diag(D);
D(D<sqrt(eps))=sqrt(eps);
Sigmatilde = L*diag(D)*L';
num = sum(min(exp(qmode-MCMC(:,1)),1).*exp(-r/2));
den = 0;
P = L*diag(sqrt(D));
x = ones(N,1)*xmode+randn(N,d)*P';
for j=1:N
    try 
        L1 = -cmd(x(j,:),gammahat,indx,theta,W);
        den = den+min(exp(L1-qmode),1); 
    catch 
        continue
    end
% Denominator of the Chib-Jeliazkov estimator
end
CJ     = qmode-log(num/den)+(d/2)*log(2*pi)+0.5*log(det(Sigmahat));

% Sims, Waggoner and Zha's r
for j=1:N
    L0 = MCMC(j,1);
    x0 = MCMC(j,2:end);
    r(j,1) = (x0-xmode)*inv(Sigmatilde)*(x0-xmode)';
end
r   = sqrt(r);
sortedr = sort(r);
c1  = sortedr(floor(0.01*N)+1,1);
c10 = sortedr(floor(0.10*N)+1,1);
c90 = sortedr(floor(0.90*N)+1,1);
nu  = log(0.1/0.9)/log(c10/c90);
a   = c1;
b   = c90/0.9^(1/nu);
g   = nu*r.^(nu-1)/(b^nu-a^nu);
ftilde = gamma(d/2)*g./(2*pi^(d/2)*sqrt(det(Sigmahat))*r.^(d-1));
sortedL = sort(MCMC(:,1));
L5  = sortedL(floor(0.5*N)+1,1);
L9  = sortedL(floor(0.1*N)+1,1);
indx9  = (MCMC(:,1)>L9)&(r>=a)&(r<=b);
indx5  = (MCMC(:,1)>L5)&indx9; 
SWZ9 = sum(ftilde(indx9,1).*exp(-MCMC(indx9,1)));
SWZ5 = sum(ftilde(indx5,1).*exp(-MCMC(indx5,1)));
D(D<sqrt(eps))=sqrt(eps);
P = L*sqrt(diag(D));
u = rand(N,1);
r = (a^nu+(b^nu-a^nu)*u).^(1/nu);
z = randn(N,d);
s = r./sqrt(sum(z.*z,2));
x = ones(N,1)*xmean+(s*ones(1,d)).*z*P';

for j=1:N
    try
        L = -cmd(x(j,:),gammahat,indx,theta,W); 
    catch
        continue
    end
    if L>L9
        tauhat9 = tauhat9+1;
        if L>L5
            tauhat5 = tauhat5+1;
        end
    end
end
SWZ5 = -log(SWZ5/tauhat5);
SWZ9 = -log(SWZ9/tauhat9);

ml     = [HM5 HM9 SWZ5 SWZ9 CJ];
