classdef parameters
    properties
        value;
        name;
        estimation;  % 1 estimate the parameter value; 0 fix the parameter value
        restriction; % 1 unit interval; 2 unit circle; 3 positive; 4 greater than unity
        prior;       % N normal distribution; P special normal distribution; I inverse gamma; G gamma; U uniform; R gamma for growth rates; B beta
        mean;
        variance;
    end
    methods
        function x=map(x)
            x.value((x.estimation==1)&(x.restriction==1)) = 1./(1+exp(x.value((x.estimation==1)&(x.restriction==1))));
            x.value((x.estimation==1)&(x.restriction==2)) = (1-exp(x.value((x.estimation==1)&(x.restriction==2))))./(1+exp(x.value((x.estimation==1)&(x.restriction==2))));
            x.value((x.estimation==1)&(x.restriction==3)) = exp(x.value((x.estimation==1)&(x.restriction==3)));
            x.value((x.estimation==1)&(x.restriction==4)) = 1+exp(x.value((x.estimation==1)&(x.restriction==4)));
        end    
        function x=imap(x)
            x.value((x.estimation==1)&(x.restriction==1)) = log((1-x.value((x.estimation==1)&(x.restriction==1)))./(x.value((x.estimation==1)&(x.restriction==1))));
            x.value((x.estimation==1)&(x.restriction==2)) = log((1-x.value((x.estimation==1)&(x.restriction==2)))./(1+x.value((x.estimation==1)&(x.restriction==2))));
            x.value((x.estimation==1)&(x.restriction==3)) = log(x.value((x.estimation==1)&(x.restriction==3)));
            x.value((x.estimation==1)&(x.restriction==4)) = log(x.value((x.estimation==1)&(x.restriction==4))-1);
        end
    end
end
