# This Julia code computes the results in tables A5-A8 in the online appendix to 
# Atsushi Inoue and Mototsugo Shintani (2017), "Quasi-Bayesian model selection"

# Date       Programmer     Description
# 12/18/2017 Atsushi Inoue  Revised

# The results reported in the paper are computed using Julia Version 0.6.1.
# The results in the paper are obtained from a 12-core workstation.

module IS2_module
    include("is2_module.jl")
end
using IS2_module
@everywhere include("is2_module.jl")
table2 = string("table2.tex") 
table3 = string("table3.tex") 
tableA5 = string("tableA5.tex")
tableA6 = string("tableA6.tex")
tableA7 = string("tableA7.tex")
tableA8 = string("tableA8.tex")
J = 20 # number of initial draws for optimization
N = 50000 # number of draws for the RWMH algorithm
ncore = nworkers() # number of cores
S = 1000 # number of bootstrap replications

rng1 = MersenneTwister(1)
rng2 = MersenneTwister(2)
rng3 = MersenneTwister(3)
rng4 = MersenneTwister(4)
rng5 = MersenneTwister(5)
rng6 = MersenneTwister(6)
rng7 = MersenneTwister(7)
rng8 = MersenneTwister(8)
rng9 = MersenneTwister(9)
rng10 = MersenneTwister(10)
rng11 = MersenneTwister(11)
rng12 = MersenneTwister(12)
rng13 = MersenneTwister(13)
rng14 = MersenneTwister(14)
rng15 = MersenneTwister(15)
rng16 = MersenneTwister(16)
rng17 = MersenneTwister(17)
rng18 = MersenneTwister(18)
rng19 = MersenneTwister(19)
rng20 = MersenneTwister(20)
rng21 = MersenneTwister(21)
rng22 = MersenneTwister(22)
rng23 = MersenneTwister(23)
rng24 = MersenneTwister(24)
rng25 = MersenneTwister(25)
rng26 = MersenneTwister(26)
rng27 = MersenneTwister(27)
rng28 = MersenneTwister(28)
rng29 = MersenneTwister(29)
rng30 = MersenneTwister(30)
rng31 = MersenneTwister(31)
rng32 = MersenneTwister(32)
rng33 = MersenneTwister(33)
rng34 = MersenneTwister(34)
rng35 = MersenneTwister(35)
rng36 = MersenneTwister(36)
rng37 = MersenneTwister(37)
rng38 = MersenneTwister(38)
rng39 = MersenneTwister(39)
rng40 = MersenneTwister(40)
rng41 = MersenneTwister(41)
rng42 = MersenneTwister(42)
rng43 = MersenneTwister(43)
rng44 = MersenneTwister(44)
rng45 = MersenneTwister(45)
rng46 = MersenneTwister(46)
rng47 = MersenneTwister(47)
rng48 = MersenneTwister(48)

T0 = 50 # number of initial observations discarded
thetaA = parameters(
#   ["kappa ","bet   ","tau   ","phip  ","phix  ","rhoz  ","rhor  ","sigmaz","sigmar"], 
    [0.0245,0.99,1.0,1.5,0.125,0.9,0.75,0.3,0.2],
    [true,false,true,false,true,false,true,false,false],
    [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0],
    [Inf,1.0,Inf,Inf,Inf,1.0,1.0,Inf,Inf],
    ['G','U','G','G','G','B','B','I','I'],
    [0.0245,0.99,1.0,1.5,0.125,0.9,0.75,0.3,0.2],
    [0.01^2,1.0,0.5^2,0.25^2,0.1^2,0.2^2,0.2^2,0.2^2,0.2^2],
    [1.0,0.3])
thetaB = parameters(
#   ["kappa ","bet   ","tau   ","phip  ","phix  ","rhoz  ","rhor  ","sigmaz","sigmar"], 
    [0.0245,0.99,1.0,1.5,0.125,0.9,0.75,0.3,0.2],
    [true,false,true,false,true,false,true,false,false],
    [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0],
    [Inf,1.0,Inf,Inf,Inf,1.0,1.0,Inf,Inf],
    ['G','U','G','G','G','B','B','I','I'],
    [0.0245,0.99,1.0,1.5,0.125,0.9,0.75,0.3,0.2],
    [0.01^2,1.0,0.5^2,0.25^2,0.1^2,0.2^2,0.2^2,0.2^2,0.2^2],
    [1.0,0.3])

s = open(table2,"a")
@printf(s,"\\scriptsize\n")
@printf(s,"\\begin{tabular}{lll|c|cccc|ccc}\\hline\n") 
@printf(s,"& & Weight & & \\multicolumn{4}{|c|}{Marginal Likelihood} & \\multicolumn{3}{c}{Modified Marginal Likelihood} \\\\ \\cline{5-11} \n")
@printf(s,"T & H & Matrix & \$\\widehat{q}_{T}\$ & Laplace & Geweke & SWZ & CJ & Geweke & SWZ & CJ \\\\ \\hline \n")
@printf(s,"\\multicolumn{11}{c}{Case 1: Model A is correctly specified and Model B is misspecified} \\\\ \\hline \n")
close(s)
s = open(table3,"a")
@printf(s,"\\footnotesize\n")
@printf(s,"\\begin{tabular}{lll|c|cccc|ccc}\\hline\n") 
@printf(s,"& & Weight & & \\multicolumn{4}{c|}{Marginal Likelihood} & \\multicolumn{3}{c}{Modified Marginal Likelihood} \\\\ \\cline{5-11} \n")
@printf(s,"T & H & Matrix & \$\\widehat{q}_{T}\$ & Laplace & Geweke & SWZ & CJ & Geweke & SWZ & CJ \\\\ \\hline \n")
@printf(s,"\\multicolumn{11}{c}{Case 3: Model A is correctly specified and Model B is misspecified} \\\\ \\hline \n")
close(s)
s = open(tableA5,"a")
@printf(s,"\\footnotesize\n")
@printf(s,"\\begin{tabular}{lll|cc|ccccc|ccccc}\\hline\n") 
@printf(s,"& & & & & \\multicolumn{6}{c|}{Marginal Likelihood} & \\multicolumn{5}{c}{Modified ML Based} \\\\ \n")
@printf(s,"& & & & & \\multicolumn{6}{c|}{on the RWMH Algorithm} & \\multicolumn{5}{c}{on the RWMH Algorithm} \\\\ \\cline{6-15} \n")
@printf(s,"& & Weight & \$\\widehat{q}_{T}\$ & Laplace & \\multicolumn{2}{c}{Geweke} & \\multicolumn{2}{c}{SWZ} & CJ & \\multicolumn{2}{c}{Geweke} & \\multicolumn{2}{c}{SWZ} & CJ \\\\ \n")
@printf(s,"T & H & Matrix & & Approx.\\ &\$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & & \$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & \\\\ \\hline \n")
close(s)
s = open(tableA6,"a")
@printf(s,"\\footnotesize\n")
@printf(s,"\\begin{tabular}{lll|cc|ccccc|ccccc}\\hline\n") 
@printf(s,"& & & & & \\multicolumn{5}{c|}{Marginal Likelihood} & \\multicolumn{5}{c}{Modified ML Based} \\\\ \n")
@printf(s,"& & & & & \\multicolumn{5}{c|}{on the RWMH Algorithm} & \\multicolumn{5}{c}{on the RWMH Algorithm} \\\\ \\cline{6-15} \n")
@printf(s,"& & Weight & \$\\widehat{q}_{T}\$ & Laplace & \\multicolumn{2}{c}{Geweke} & \\multicolumn{2}{c}{SWZ} & CJ & \\multicolumn{2}{c}{Geweke} &\\multicolumn{2}{c}{SWZ} & CJ \\\\ \n")
@printf(s,"T & H & Matrix & & Approx.\\ &\$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & & \$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & \\\\ \\hline \n")
close(s)
s = open(tableA7,"a")
@printf(s,"\\scriptsize\n")
@printf(s,"\\begin{tabular}{lll|cc|ccccc|ccccc}\\hline\n") 
@printf(s,"& & & & & \\multicolumn{5}{c|}{Marginal Likelihood} & \\multicolumn{5}{c}{Modified ML Based} \\\\ \n")
@printf(s,"& & & & & \\multicolumn{5}{c|}{on the RWMH Algorithm} & \\multicolumn{5}{c}{on the RWMH Algorithm} \\\\ \\cline{6-15} \n")
@printf(s,"& & Weight & \$\\widehat{q}_{T}\$ & Laplace & \\multicolumn{2}{c}{Geweke} & \\multicolumn{2}{c}{SWZ} & CJ & \\multicolumn{2}{c}{Geweke} &\\multicolumn{2}{c}{SWZ} & CJ \\\\ \n")
@printf(s,"T & H & Matrix & & Approx.\\ &\$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & & \$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & \\\\  \n")
close(s)
s = open(tableA8,"a")
@printf(s,"\\scriptsize\n")
@printf(s,"\\begin{tabular}{lll|cc|ccccc|ccccc}\\hline\n") 
@printf(s,"& & & & & \\multicolumn{5}{c|}{Marginal Likelihood} & \\multicolumn{5}{c}{Modified ML Based} \\\\ \n")
@printf(s,"& & & & & \\multicolumn{5}{c|}{on the RWMH Algorithm} & \\multicolumn{5}{c}{on the RWMH Algorithm} \\\\ \\cline{6-15} \n")
@printf(s,"& & Weight & \$\\widehat{q}_{T}\$ & Laplace & \\multicolumn{2}{c}{Geweke} & \\multicolumn{2}{c}{SWZ} & CJ & \\multicolumn{2}{c}{Geweke} &\\multicolumn{2}{c}{SWZ} & CJ \\\\ \n")
@printf(s,"T & H & Matrix & & Approx.\\ &\$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & & \$\\tau=0.5\$ & \$\\tau=0.9\$ & \$q=0.5\$ & \$q=0.9\$ & \\\\  \n")
close(s)

for experiment = 1:4 
    # 1 uses all irfs for misspecification
    # 2 uses all irfs for parsimony
    # 3 uses irfs to technology shock for misspecification, 
    # 4 uses irfs to technology shock for parsimony  
    if experiment==2
        s = open(table2,"a")
        @printf(s,"\\hline \n")
        @printf(s,"\\multicolumn{11}{c}{Case 2: Model A is more parsimonious than model Model B} \\\\ \\hline \n")
        close(s)
    end
    if experiment==4
        s = open(table3,"a")
        @printf(s,"\\hline \n")
        @printf(s,"\\multicolumn{11}{c}{Case 4: Model A is more parsimonious than model Model B} \\\\ \\hline \n")
        close(s)
    end
    for T in [50,100,200] # sample size 
        pmax = round(Int,5.0*(T/log(T))^0.25) # maximum lag order length of VAR
        #pmax = round(Int,5.0*(T/log(T))^(1.0/6.0)) # maximum lag order length of VAR
        for H in [2,4,8] # maximum horizon    
            pmin = H # minimum lag order length of VAR
            if (experiment==1)|(experiment==2)     
                indx = vec([1:2;4:4*(H+1)]) # all impulse responses
            elseif (experiment==3)|(experiment==4) 
                indx = 1
                for i=1:H
                    indx = [indx;(1+4*i):(2+4*i)]
                end
                indx = vec(indx) # impulse responses to the technology shock
            end
            if (experiment==1)|(experiment==3)
                thetaA.estimation[1] = true
                thetaB.estimation[1] = true
                thetaA.estimation[3] = true
                thetaB.estimation[3] = false
                thetaB.mean[3]       = 3.0 
                thetaB.value[3]      = 3.0
            elseif (experiment==2)|(experiment==4)
                thetaA.estimation[1] = false
                thetaB.estimation[1] = true
                thetaA.estimation[3] = true
                thetaB.estimation[3] = true
                thetaB.mean[3]       = 1.0 
                thetaB.value[3]      = 1.0
            end
            arg1 = Any[H,indx,J,pmax,pmin,rng1,10,N,S,T,T0,thetaA,thetaB]
            arg2 = Any[H,indx,J,pmax,pmin,rng2,10,N,S,T,T0,thetaA,thetaB]
            arg3 = Any[H,indx,J,pmax,pmin,rng3,10,N,S,T,T0,thetaA,thetaB]
            arg4 = Any[H,indx,J,pmax,pmin,rng4,10,N,S,T,T0,thetaA,thetaB]
            arg5 = Any[H,indx,J,pmax,pmin,rng5,10,N,S,T,T0,thetaA,thetaB]
            arg6 = Any[H,indx,J,pmax,pmin,rng6,10,N,S,T,T0,thetaA,thetaB]
            arg7 = Any[H,indx,J,pmax,pmin,rng7,10,N,S,T,T0,thetaA,thetaB]
            arg8 = Any[H,indx,J,pmax,pmin,rng8,10,N,S,T,T0,thetaA,thetaB]
            arg9 = Any[H,indx,J,pmax,pmin,rng9,10,N,S,T,T0,thetaA,thetaB]
            arg10 = Any[H,indx,J,pmax,pmin,rng10,10,N,S,T,T0,thetaA,thetaB]
            arg11 = Any[H,indx,J,pmax,pmin,rng11,10,N,S,T,T0,thetaA,thetaB]
            arg12 = Any[H,indx,J,pmax,pmin,rng12,10,N,S,T,T0,thetaA,thetaB]
	    arg13 = Any[H,indx,J,pmax,pmin,rng13,10,N,S,T,T0,thetaA,thetaB]
            arg14 = Any[H,indx,J,pmax,pmin,rng14,10,N,S,T,T0,thetaA,thetaB]
            arg15 = Any[H,indx,J,pmax,pmin,rng15,10,N,S,T,T0,thetaA,thetaB]
            arg16 = Any[H,indx,J,pmax,pmin,rng16,10,N,S,T,T0,thetaA,thetaB]
            arg17 = Any[H,indx,J,pmax,pmin,rng17,10,N,S,T,T0,thetaA,thetaB]
            arg18 = Any[H,indx,J,pmax,pmin,rng18,10,N,S,T,T0,thetaA,thetaB]
            arg19 = Any[H,indx,J,pmax,pmin,rng19,10,N,S,T,T0,thetaA,thetaB]
            arg20 = Any[H,indx,J,pmax,pmin,rng20,10,N,S,T,T0,thetaA,thetaB]
            arg21 = Any[H,indx,J,pmax,pmin,rng21,10,N,S,T,T0,thetaA,thetaB]
            arg22 = Any[H,indx,J,pmax,pmin,rng22,10,N,S,T,T0,thetaA,thetaB]
            arg23 = Any[H,indx,J,pmax,pmin,rng23,10,N,S,T,T0,thetaA,thetaB]
            arg24 = Any[H,indx,J,pmax,pmin,rng24,10,N,S,T,T0,thetaA,thetaB]
	    results = pmap((args)->is2_function(args...),Any[arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20,arg21,arg22,arg23,arg24])
            r = sum(results)
	    arg1 = Any[H,indx,J,pmax,pmin,rng25,10,N,S,T,T0,thetaA,thetaB]
            arg2 = Any[H,indx,J,pmax,pmin,rng26,10,N,S,T,T0,thetaA,thetaB]
            arg3 = Any[H,indx,J,pmax,pmin,rng27,10,N,S,T,T0,thetaA,thetaB]
            arg4 = Any[H,indx,J,pmax,pmin,rng28,10,N,S,T,T0,thetaA,thetaB]
            arg5 = Any[H,indx,J,pmax,pmin,rng29,11,N,S,T,T0,thetaA,thetaB]
            arg6 = Any[H,indx,J,pmax,pmin,rng30,11,N,S,T,T0,thetaA,thetaB]
            arg7 = Any[H,indx,J,pmax,pmin,rng31,11,N,S,T,T0,thetaA,thetaB]
            arg8 = Any[H,indx,J,pmax,pmin,rng32,11,N,S,T,T0,thetaA,thetaB]
            arg9 = Any[H,indx,J,pmax,pmin,rng33,11,N,S,T,T0,thetaA,thetaB]
            arg10 = Any[H,indx,J,pmax,pmin,rng34,11,N,S,T,T0,thetaA,thetaB]
            arg11 = Any[H,indx,J,pmax,pmin,rng35,11,N,S,T,T0,thetaA,thetaB]
            arg12 = Any[H,indx,J,pmax,pmin,rng36,11,N,S,T,T0,thetaA,thetaB]
            arg13 = Any[H,indx,J,pmax,pmin,rng37,11,N,S,T,T0,thetaA,thetaB]
            arg14 = Any[H,indx,J,pmax,pmin,rng38,11,N,S,T,T0,thetaA,thetaB]
            arg15 = Any[H,indx,J,pmax,pmin,rng39,11,N,S,T,T0,thetaA,thetaB]
            arg16 = Any[H,indx,J,pmax,pmin,rng40,11,N,S,T,T0,thetaA,thetaB]
            arg17 = Any[H,indx,J,pmax,pmin,rng41,11,N,S,T,T0,thetaA,thetaB]
            arg18 = Any[H,indx,J,pmax,pmin,rng42,11,N,S,T,T0,thetaA,thetaB]
            arg19 = Any[H,indx,J,pmax,pmin,rng43,11,N,S,T,T0,thetaA,thetaB]
            arg20 = Any[H,indx,J,pmax,pmin,rng44,11,N,S,T,T0,thetaA,thetaB]
	    arg21 = Any[H,indx,J,pmax,pmin,rng45,11,N,S,T,T0,thetaA,thetaB]
            arg22 = Any[H,indx,J,pmax,pmin,rng46,11,N,S,T,T0,thetaA,thetaB]
            arg23 = Any[H,indx,J,pmax,pmin,rng47,11,N,S,T,T0,thetaA,thetaB]
            arg24 = Any[H,indx,J,pmax,pmin,rng48,11,N,S,T,T0,thetaA,thetaB]
      	    results = pmap((args)->is2_function(args...),Any[arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20,arg21,arg22,arg23,arg24])
            r = r+sum(results)
	    r = r/500.0	    
	    
	    if (experiment==1)|(experiment==2)
	        s = open(table2,"a")
            elseif (experiment==3)|(experiment==4)
	        s = open(table3,"a")
            end
            for i=1:2
                if (i==1)
                    @printf(s,"%3d & %1d & Diag ",T,H)
                else
                    @printf(s," & & Opt ")
                end
                for j=1:2
                    @printf(s,"& %5.2f ",r[i,j])
                end
                for j=1:2
                    @printf(s,"& %5.2f ",r[i,4+2*(j-1)])
                end
                @printf(s,"& %5.2f ",r[i,7])
                for j=1:2
                    @printf(s,"& %5.2f ",r[i,9+2*(j-1)])
                end
                @printf(s,"& %5.2f \\\\ \n",r[i,12])
            end
            close(s)
            if (experiment==1)
	        s = open(tableA5,"a")
            elseif (experiment==2)
	        s = open(tableA6,"a")
            elseif (experiment==3)
	        s = open(tableA7,"a")
            elseif (experiment==4)
	        s = open(tableA8,"a")
	    end
	    for i=1:2
                if (i==1)
                    @printf(s,"%3d & %1d & Diag ",T,H)
                else
                    @printf(s," & & Opt ")
                end
                for j=1:12
                    @printf(s,"& %5.2f ",r[i,j])
                end
                @printf(s,"\\\\ \n")
            end
            close(s)
        end
        if (experiment==1)|(experiment==2)
            s = open(table2,"a")
        elseif (experiment==3)|(experiment==4)
            s = open(table3,"a")
        end
 	@printf(s,"\\hline \n")
        close(s)
	if (experiment==1)
	    s = open(tableA5,"a")
        elseif (experiment==2)
	    s = open(tableA6,"a")
        elseif (experiment==3)
	    s = open(tableA7,"a")
        elseif (experiment==4)
	    s = open(tableA8,"a")
	end
	@printf(s,"\\hline \n")
        close(s)
    end
    if (experiment==2)
        s = open(table2,"a")
        @printf(s,"\\end{tabular} \n")
        close(s)
    end
    if experiment==4
        s = open(table3,"a")
        @printf(s,"\\end{tabular} \n")
        close(s)
    end
    if (experiment==1)
        s = open(tableA5,"a")
    elseif (experiment==2)
        s = open(tableA6,"a")
    elseif (experiment==3)
        s = open(tableA7,"a")
    elseif (experiment==4)
        s = open(tableA8,"a")
    end
    @printf(s,"\\end{tabular} \n")
    close(s)
end
