%% Bayesian GMM estimation for GNKPC
n_simu=1;

%% (A) if getting an initial mcmc parameter, set mcmc=0
% settings for MCMC
M=K*20;% number of MCMC sampling 
N=K+M; % number of total_sampling


%% (B) choose model to estimate
%sample_period=sample_period_definition(US,sample);

%% for check
[model, sample_period] % just displaying

%% (F) loading data from excel file
[X,Y,Z]=data_load(sample_period, US, cpi, IV, rho,lead);

if strcmp(dist_name(3),'N')

%para_fix(3)=mean(Y);
Y_fullsample=Z.Y_fullsample;
eval(char(treat_meanPi)) % para_pri(3,1)=mean(Y);
eval(char(treat_iniPi))

end

%% for 2-step GMM
if TSGMM==1
[W,LAMBDA]=TwoStepGMM_WM(Y,X,Z,para_fix,model,denominator,NWlags,para_estim,para_ini,para_pri,iniWM);
Z.W=W;
Z.LAMBDA=LAMBDA;
Z.TSGMM=1;
else
Z.TSGMM=0;
end

%% getting MCMC initial parameters 

[negative_Lmode,xhat,ghat,Hhat,itct,fcount,retcodehat] = ... 
csminwel(@(para)find_posterior_mode(Y,X,Z,para,para_fix,para_pri,model,denominator,NWlags,para_estim),para_ini(para_estim==1),eye(length(para_ini(para_estim==1))),[] ,1e-14,100);
%[xhat,negative_Lmode,exitflag,output,grad,Hhat]=...
%      fminunc(@(para)find_posterior_mode(Y,X,Z,para,para_fix,para_pri,model,denominator,NWlags,para_estim),para_ini(para_estim==1));
% Hhat=inv(Hhat);        

paramod=para_fix;
paramod(para_estim==1)=xhat;
[S, V, D]=svd(Hhat);
hess_opt=S*V*S'; % to avoid non-positive-definite variance matrix
para=paramod;

disp('Posterior mode')
[para(1:2);para(3)*4;para(4:6)]

%% MCMC

   
%% adjusting hessian matrix
hess=hess_opt* adjust_param; % for adjust the acceptance ratio


%% MCMC
sample_period_des
disp(['now drawing for model',num2str(model),' for ',period_name,'...'])

%% preparing boxes for parameters
para_s=zeros(N,size(para_ini,1));
loglike_s=zeros(N,1);
logpri_s=zeros(N,1);   

%% evaluating the likelihood and prior functions
% likelihood and prior at posterior mode

[loglike]=lik_GMM(Y,X,Z,paramod,para_fix,model,denominator,NWlags,para_estim);
logpri=prior(paramod,para_pri);

loglikelogpri=loglike+logpri;

% initial value for the acceptance rate, 
ppacc=0;
violation_test=0;

h_bar = waitbar(0,'Please wait...'); % for wait bar

j=1;
para=paramod; % initial parameter
para_S(1,:)=para';
loglike_s(1,:)=loglike;
logpri_s(1,:)=logpri;

% repetedly drawing
while j<N

    % applicant parameter
    newpara=para;
    newpara(para_estim==1) = para(para_estim==1) + mvnrnd(zeros(1,size(para_ini(para_estim==1),1)),hess)'; 
    %newpara(para_estim==0)=para_fix(para_estim==0);
    
    newlogpri=prior(newpara,para_pri);
    
    if (model==1||model==3||model==4)&& violation_check(newpara,para_fix,para_estim)==1
        j=j-1;
        violation_test=violation_test+1;
    else
        [newloglike]=lik_GMM(Y,X,Z,newpara,para_fix,model,denominator,NWlags,para_estim);
        ratio=exp(newloglike+newlogpri-(loglike+logpri));
        if rand<=ratio % we accept with prob ratio
            loglike=newloglike;
            logpri=newlogpri;
            para=newpara;
            ppacc=ppacc+1;
        end
        para_s(j+1,:)=para';
        loglike_s(j+1,1)=loglike;
        logpri_s(j+1,1)=logpri;
    end
    
    j=j+1;

    if j==K
        ppacc_burnin=ppacc/K*100;
        ppacc=0;
        violation_burnin=violation_test/K*100;
        violation_test=0;
    end

    if j<K
        waitbar(j / N,h_bar,strcat('acceptance ratio for burn-in :  ',sprintf('%3.2f',ppacc/j*100)));
    else
        waitbar(j / N,h_bar,strcat('acceptance ratio after burn-in :   ',sprintf('%3.2f',ppacc/(j-K)*100)));
    end

end
close(h_bar)

% saving acceptance rate
ppacc=ppacc/M*100;
violation_test=violation_test/M*100;

%% arranging results
para_store=para_s;
loglike_store=loglike_s;
logpri_store=logpri_s;
para_s=para_store(K+1:K+M,:);
loglike_s=loglike_store(K+1:K+M,:);
logpri_s=logpri_store(K+1:K+M,:);

cal_slope
para_s=[para_s(:,1:6),slope];

% annualizing trend inflation 
para_s(:,3)=para_s(:,3)*4; % making inflation rate annual rate 

% print out moments of the posterior
postmeds  = median(para_s,1);
postmeans = mean(para_s,1);
poststds  = std(para_s,0,1);
postmins  = min(para_s,[],1);
postmaxs  = max(para_s,[],1);

%% post analysis
post_analysis

% save mcmc results
save(savefile)


