

%% set sample period
sample_period=sample_period_definition(US,sample);

%% data loading
[X,Y,Z]=data_load(sample_period, US, cpi, IV, 1);
% X=[pi_b1, pi_f1, pi_f2, w, w_f1, l, l_f1, y, y_f1, r, ulc, ulc_f1,l_b1,l_b2,y_b1,y_b2];

pi_b1=X(:,1); %pi(t-1)
pi_f1=X(:,2); %pi(t+1)
pi_f2=X(:,3); %pi(t+2)
w=X(:,4); %w(t)
w_f1=X(:,5); %w(t+1)
l=X(:,6); %l(t)
l_f1=X(:,7); % l(t+1)
l_b1=X(:,13); % l(t-1)
l_b2=X(:,14); % l(t-2)
y=X(:,8); % y(t)
y_f1=X(:,9); % y(t+1)
y_b1=X(:,15); % y(t-1)
y_b2=X(:,16); % y(t-2)
r=X(:,10); % r(t)
ulc=X(:,11); % ulc(t)
ulc_f1=X(:,12); % ulc(t+1)

% explanatory variables for GNKPC and NKPC 
if model==7
    X=[ones(size(Y,1),1),pi_b1, pi_f1, pi_f2, y, y_f1, ulc, ulc_f1, l, l_f1, r];
elseif model==8
    X=[ones(size(Y,1),1),pi_b1, pi_f1, ulc];
end
% instrumental variable matrix

Ztemp=Z.Z1;
clear Z
Z=Ztemp;


%% 2SLS estimator
if matform==1
    beta_hat2 = ((X'*Z)*(Z'*X))\((X'*Z)*(Z'*Y));
elseif matform==0
    beta_hat2 = ((X'*Z)*((Z'*Z)\(Z'*X)))\((X'*Z)*((Z'*Z)\(Z'*Y)));
end

% residual vector
u_hat2 = Y - X * beta_hat2;

% moment conditions
Zu=Z.*repmat(u_hat2,1,size(Z,2));

[W, LAMBDA]=weighting_mat(Zu,NWlags);

%% GMM estimator
beta_hat = (X'*Z/LAMBDA*Z'*X)\(X'*Z/LAMBDA*Z'*Y);

%% variance matrix of GMM estimator
u_hat = Y - X*beta_hat;
Zu=Z.*repmat(u_hat,1,size(Z,2));

[W, LAMBDA]=weighting_mat(Zu,NWlags);

V = inv((X'*Z)/(LAMBDA*length(X))*(Z'*X));
SE = diag(real(V.^0.5));

%% output

tag_h={'','coef','std', 't-value'};
if model==7
    tag_v={'const.','pi_b1', 'pi_f1', 'pi_f2',  'y', 'y_f1','ulc', 'ulc_f1', 'l','l_f1' 'r'}';
elseif model==8
    tag_v={'const.', 'pi_b1', 'pi_f1', 'ulc'}';
end
display('Reduced form results')
[tag_h;[tag_v,num2cell([beta_hat,SE, beta_hat./SE])]]

display('estimated trend inflation')
if model==7
    trend_infl=beta_hat(1)/(1-beta_hat(2)-beta_hat(3)-beta_hat(5));
    kappa=beta_hat(7)^2/(beta_hat(7)+beta_hat(2)*beta_hat(8))
elseif model==8
    trend_infl=beta_hat(1)/(1-beta_hat(2)-beta_hat(3));
    kappa=beta_hat(3)
end
trend_infl=(trend_infl-1)*400
