%% slope of the (generalized) Phillips Curve

omega_post=para_s(:,1);
lambda_post=para_s(:,2);
Pistar_post=1+para_s(:,3)/100;
theta_post=para_s(:,4);
alpha_post=para_s(:,5);
beta_post=para_s(:,end);

% theta=para_fix(1);
% alpha=para_fix(2);
% beta=para_fix(3);

%% useful definition

A_post=lambda_post.*Pistar_post.^(theta_post-1);
A2_post=lambda_post.*Pistar_post.^(theta_post);
phi_post=A_post+omega_post.*(1-A_post.*(1-beta_post.*Pistar_post));

% coefficients of GNKPC
Gb_post=omega_post./phi_post;
Gf_post=beta_post.*A2_post./phi_post;
K_post=(1-omega_post).*(1-A_post).*(1-beta_post.*A2_post)./phi_post;
Kf_post=(Pistar_post-1).*(1-omega_post).*(1-A_post)./phi_post;
Kd_post=theta_post.*A_post.*(Pistar_post-1)./(1-A_post);

% coefficients of NKPC

phi1_post=lambda_post+omega_post.*(1-lambda_post.*(1-beta_post));

Gb1_post=omega_post./phi1_post;
Gf1_post=beta_post.*lambda_post./phi1_post;
K1_post =(1-lambda_post).*(1-beta_post.*lambda_post).*(1-omega_post)./(phi1_post);

% coefficients of Cogley-Sbordone type GNKPC

Ac_post=lambda_post.*Pistar_post.^((theta_post-1).*(1-omega_post));
phic_post = 1+omega_post.*beta_post.*Pistar_post.^(1-omega_post);

Gbc_post=omega_post./phic_post;
Gfc_post=beta_post.*Pistar_post.^(1-omega_post)./phic_post;
Kc_post=(1-Ac_post).*(1-beta_post.*lambda_post.*Pistar_post.^(theta_post.*(1-omega_post)))./(Ac_post.*phic_post);
Kfc_post=(Pistar_post.^(1-omega_post)-1).*(1-Ac_post)./(Ac_post.*phic_post);
Kdc_post=theta_post.*Ac_post.*(Pistar_post.^(1-omega_post)-1)./(1-Ac_post);

% coefficients of NKPC with partial price indexation to lagged inflation
phic1_post=1+omega_post.*beta_post;

Gbc1_post=omega_post./phic1_post;
Gfc1_post=beta_post./phic1_post;
Kc1_post =(1-lambda_post).*(1-beta_post.*lambda_post)./(lambda_post.*phic1_post);


%% GNKPC
if model==1 || model==3 || model==4

% slope
    slope=K_post;
    gamma_b=Gb_post;
    gamma_f=Gf_post;
    kappa_f=Kf_post;
    kappa_d=Kdc_post;
    
    if model==4
        kappa_f=kappa_f*0;
    end
    
    if model==3
        kappa_d=kappa_d*0;
    end
    

%% NKPC
elseif model==2
    slope=K1_post;
    gamma_b=Gb1_post;
    gamma_f=Gf1_post;
    kappa_f=K1_post*0;
    kappa_d=K1_post*0;
    
%% Cogley-Sbordone type GNKPC    
elseif model==5||model==7||model==8
    
slope=Kc_post;
gamma_b=Gbc_post;
gamma_f=Gfc_post;
kappa_f=Kfc_post;
kappa_d=Kdc_post;

if model==8
    kappa_f=kappa_f*0;
end

if model==7
    kappa_d=kappa_d*0;
end

%% NKPC with partial indexation to lagged inflation
elseif model==6
    
    slope=Kc1_post;
    gamma_b=Gbc1_post;
    gamma_f=Gfc1_post;
    kappa_f=Kc1_post*0;
    kappa_d=Kc1_post*0;
end 
    