
% A: mean, B: std
n_sim=10000;
para_pri_draw=zeros(n_sim,6);

%% omega
A_o=para_pri(1,1);
B_o=para_pri(1,2);

%% lambda
A_l=para_pri(2,1);
B_l=para_pri(2,2);

%% Pistar
A_p=para_pri(3,1);
B_p=para_pri(3,2);

%% theta
A_t=para_pri(4,1);
B_t=para_pri(4,2);

%% alpha
A_a=para_pri(5,1);
B_a=para_pri(5,2);

%% beta
A_b=para_pri(6,1);
B_b=para_pri(6,2);

%{
%% rho
A_r=para_pri(6,1);
B_r=para_pri(6,2);
%}

%% draw random variable for each parameter

n_draw=n_sim;
counter=0;
while n_draw>0
% omega
if para_estim(1)==1
    omega_pri=random('beta',A_o^2*(1-A_o)/B_o^2-A_o,(1-A_o)/A_o*(A_o^2*(1-A_o)/B_o^2-A_o),n_draw,1);
    %omega=1-1./(1+random('gamma',A^2*(1-A)/B^2-A,(1-A)/A*(A^2*(1-A)/B^2-A),1,1));
else
    omega_pri=ones(n_draw,1)*para_fix(1);
end

% lambda
if para_estim(2)==1
    lambda_pri=random('beta',A_l^2*(1-A_l)/B_l^2-A_l,(1-A_l)/A_l*(A_l^2*(1-A_l)/B_l^2-A_l),n_draw,1);
else
    lambda_pri=ones(n_draw,1)*para_fix(2);
end

% Pistar
if para_estim(3)==1
    Pistar1_pri=random('norm', A_p,B_p,n_draw,1);
else
    Pistar1_pri=ones(n_draw,1)*para_fix(3);
end

% theta
if para_estim(4)==1
    theta_pri=random('gam',A_t^2/B_t^2,B_t^2/A_t,n_draw,1 );
else
    theta_pri=ones(n_draw,1)*para_fix(4);
end

% alpha
if para_estim(5)==1
    alpha_pri=random('beta',A_a^2*(1-A_a)/B_a^2-A_a,(1-A_a)/A_a*(A_a^2*(1-A_a)/B_a^2-A_a),n_draw,1);
else
    alpha_pri=ones(n_draw,1)*para_fix(5);
end

% beta
if para_estim(6)==1
    beta_pri=(random('gam',A_b^2/B_b^2,B_b^2/A_b,n_draw,1 )/100+1).^(-1);
else
    beta_pri=ones(n_draw,1)*para_fix(6);
end


%% violation check
if (model==2)
    para_pri_draw=[omega_pri, lambda_pri, Pistar1_pri,theta_pri,alpha_pri,beta_pri];
    n_draw=0;
else
    draw=[omega_pri, lambda_pri, Pistar1_pri,theta_pri,alpha_pri,beta_pri];
    
    assumption1=beta_pri.*lambda_pri.*(1+Pistar1_pri/100).^(theta_pri-1);
    assumption2=beta_pri.*lambda_pri.*(1+Pistar1_pri/100).^(theta_pri./alpha_pri);
    
    violation=(assumption1>=1)+(assumption2>=1);
    n_alive=sum(violation==0);
    para_non_violate=reshape(draw(repmat(violation,[1,6])==0),[n_alive,6]);
    para_pri_draw(counter+1:counter+n_alive,:)=para_non_violate;
    counter=counter+n_alive;
    n_draw=n_sim-counter;

end    
end

omega_pri=para_pri_draw(:,1);
lambda_pri=para_pri_draw(:,2);
Pistar1_pri=para_pri_draw(:,3);
theta_pri=para_pri_draw(:,4);
alpha_pri=para_pri_draw(:,5);
beta_pri=para_pri_draw(:,6);


%figure
slope_pri=zeros(n_sim,1);

%% kappa

Pistar_pri=1+Pistar1_pri/100;

%% useful definition

A_pri=lambda_pri.*Pistar_pri.^(theta_pri-1);
A2_pri=lambda_pri.*Pistar_pri.^(theta_pri);
phi_pri=A_pri+omega_pri.*(1-A_pri.*(1-beta_pri.*Pistar_pri));

% coefficients of GNKPC
Gb_pri=omega_pri./phi_pri;
Gf_pri=beta_pri.*A2_pri./phi_pri;
K_pri=(1-omega_pri).*(1-A_pri).*(1-beta_pri.*A2_pri)./phi_pri;
Kf_pri=(Pistar_pri-1).*(1-omega_pri).*(1-A_pri)./phi_pri;
Kd_pri=theta_pri.*A_pri.*(Pistar_pri-1)./(1-A_pri);

% coefficients of NKPC

phi1_pri=lambda_pri+omega_pri.*(1-lambda_pri.*(1-beta_pri));

Gb1_pri=omega_pri./phi1_pri;
Gf1_pri=beta_pri.*lambda_pri./phi1_pri;
K1_pri =(1-lambda_pri).*(1-beta_pri.*lambda_pri).*(1-omega_pri)./(phi1_pri);

% coefficients of Cogley-Sbordone type GNKPC

Ac_pri=lambda_pri.*Pistar_pri.^((theta_pri-1).*(1-omega_pri));
phic_pri = 1+omega_pri.*beta_pri.*Pistar_pri.^(1-omega_pri);

Gbc_pri=omega_pri./phic_pri;
Gfc_pri=beta_pri.*Pistar_pri.^(1-omega_pri)./phic_pri;
Kc_pri=(1-Ac_pri).*(1-beta_pri.*lambda_pri.*Pistar_pri.^(theta_pri.*(1-omega_pri)))./(Ac_pri.*phic_pri);
Kfc_pri=(Pistar_pri.^(1-omega_pri)-1).*(1-Ac_pri)./(Ac_pri.*phic_pri);
Kdc_pri=theta_pri.*Ac_pri.*(Pistar_pri.^(1-omega_pri)-1)./(1-Ac_pri);

% coefficients of NKPC with partial price indexation to lagged inflation
phic1_pri=1+omega_pri.*beta_pri;

Gbc1_pri=omega_pri./phic1_pri;
Gfc1_pri=beta_pri./phic1_pri;
Kc1_pri =(1-lambda_pri).*(1-beta_pri.*lambda_pri)./(lambda_pri.*phic1_pri);

%% GNKPC
if model==1||model==3||model==4
    
% slope_pri
slope_pri(:,1)=K_pri;
gamma_b_pri(:,1)=Gb_pri;
gamma_f_pri(:,1)=Gf_pri;
kappa_f_pri(:,1)=Kf_pri;
kappa_d_pri(:,1)=Kd_pri;

if model==3
    kappa_d_pri=kappa_d_pri*0;
end

if model==4
    kappa_f_pri=kappa_f_pri*0;
end

%% NKPC
elseif model==2

    slope_pri(:,1)=K1_pri;
    gamma_b_pri(:,1)=Gb1_pri;
    gamma_f_pri(:,1)=Gf1_pri;
    kappa_f_pri(:,1)=K1_pri*0;
    kappa_d_pri(:,1)=K1_pri*0;

%% Cogley-Sbordone type GNKPC    
elseif model==5||model==7||model==8
    
% slope_pri
slope_pri(:,1)=Kc_pri;
gamma_b_pri(:,1)=Gbc_pri;
gamma_f_pri(:,1)=Gfc_pri;
kappa_f_pri(:,1)=Kfc_pri;
kappa_d_pri(:,1)=Kdc_pri;

if model==8
    kappa_f_pri=kappa_f_pri*0;
end

if model==7
    kappa_d_pri=kappa_d_pri*0;
end

%% NKPC with partial indexation to lagged inflation
elseif model==6
    
    slope_pri(:,1)=Kc1_pri;
    gamma_b_pri(:,1)=Gbc1_pri;
    gamma_f_pri(:,1)=Gfc1_pri;
    kappa_f_pri(:,1)=Kc1_pri*0;
    kappa_d_pri(:,1)=Kc1_pri*0;
end
%{
% plot
[f,x] = ksdensity(slope_pri(:,1));
plot(x,f)
title('\kappa1')
hold on
%}

%% credible interval
%sorted=sort(slope_pri(:,1));
%CI_kappa(1,1)=sorted(length(sorted)*0.05,1);
%CI_kappa(1,2)=sorted(length(sorted)*0.95,1);

    
%disp('mean, std. error')
[para_pri(3,1), mean(slope_pri(:,1)), std(slope_pri(:,1))];


%disp('90 % credible interval');
%CI_kappa;





