% creating prior.m file
para_name={'omega','lambda','trend inflation','theta','alpha','beta'};
fileID=fopen('prior.m','w');

fprintf(fileID,'function [p]=prior(para,para_pri)\n\n');
fprintf(fileID,'p=0;\n');

n_estim=size(para_pri,1);



for ii=1:n_estim

    if (para_estim(ii)==1)&&(strcmp('G', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Gamma distribution \n']);        
        formatSpec = '   p=log(gampdf2(para(%d),para_pri(%d,1),para_pri(%d,2) ))+p;\n\n';
        fprintf(fileID,formatSpec, ii, ii,ii);
    elseif (para_estim(ii)==1)&&(strcmp('B', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Beta distribution \n']);  
        formatSpec = '   p=log(betapdf2(para(%d), para_pri(%d,1),para_pri(%d,2) ))+p;\n\n';
        fprintf(fileID,formatSpec, ii, ii,ii);
    elseif (para_estim(ii)==1)&&(strcmp('N', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Normal distribution \n']);  
        formatSpec = '   p=log(normpdf(para(%d),para_pri(%d,1),para_pri(%d,2) ))+p;\n\n';
        fprintf(fileID,formatSpec, ii, ii,ii);
    elseif (para_estim(ii)==1)&&(strcmp('InvG', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Inverse Gamma distribution \n']);  
        formatSpec = '   p=log(inversegampdf2(para(%d), para_pri(%d,1),para_pri(%d,2) ))+p;\n\n';
        fprintf(fileID,formatSpec, ii, ii,ii);
    elseif (para_estim(ii)==1)&&(strcmp('U', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Uniform distribution \n']);  
        formatSpec = ' if (para(%d)< para_pri(%d,1)) || (para_pri(%d,2)<para(%d)) \n   p=-Inf; \n end \n\n';
        fprintf(fileID,formatSpec, ii, ii,ii,ii);
    elseif (para_estim(ii)==1)&&(strcmp('VTG', dist_name(ii))==1)
        fprintf(fileID,[' %%', char(para_name(ii)), ' - Variable Transformed Gamma distribution \n']);  
        formatSpec = '   p=log(100*gampdf2(100*(1/para(%d)-1), 100*(1/para_pri(%d,1) -1),para_pri(%d,2)))+p; \n\n';
        fprintf(fileID,formatSpec, ii, ii,ii);
    end
end

fprintf(fileID,'\n end  \n');

fprintf(fileID,'\n %% defining pdf function  \n');
fprintf(fileID,'function [ Y ] = inversegampdf2( X,mu,se ) \n');
fprintf(fileID,'   A=mu^2/se^2+2; \n');
fprintf(fileID,'   B=mu*(A-1); \n');
fprintf(fileID,'   Y = (X>0)*B^A/gamma(A)*X.^(-A-1).*exp(-B./X); \n');
fprintf(fileID,'end \n\n');

fprintf(fileID,'function x=betapdf2(X,A,B) \n');
fprintf(fileID,'   a=A^2*(1-A)/B^2-A; \n');
fprintf(fileID,'   b=(1-A)/A*a; \n');
fprintf(fileID,'   x=betapdf(X,a,b); \n');
fprintf(fileID,'end \n\n');

fprintf(fileID,'function [x]=gampdf2(X,A,B) \n');
fprintf(fileID,'   a=A^2/B^2; \n');
fprintf(fileID,'   b=B^2/A; \n');
fprintf(fileID,'   x=gampdf(X,a,b); \n');
fprintf(fileID,'end \n');