% plot graphs

sample_period=[5, 181];  % all saamples
%% loading data from excel file
%% data sample period
rawData = xlsread('JPdata0527.xlsx','JPdata');
data=rawData(sample_period(1)-4:sample_period(2)+2,:); 

quarter_t=data(:,1);
GDP_cpi=data(:,2); %100*ln( )
GDP_def=data(:,3); %100*ln( )
Hours=data(:,4); %100*ln( )
inf_cpi=data(:,5); % quarterly, %
inf_def=data(:,6); % quarterly, %
Wage_cpi=data(:,7); %100*ln( )
Wage_def=data(:,8);%100*ln( )
TB3M=data(:,9); % not gross, quarterly, %
L_s_Spread=data(:,16); % not gross, quarterly, %
CRBinflation=data(:,10); % quarterly, %
share_MT=data(:,11); % 0.XX (not percent) % definition used by Tsuruga & Muto
share=data(:,12); % 0.XX (not percent)

GDPgrowth=data(:,13);  % quarterly, %
Wagegrowth_cpi=data(:,14); % quarterly, % 
Wagegrowth_def=data(:,15); % quarterly, %

one1=ones(length(data),1);

cpi=1; % 1 if use cpi as inflation, otherwise GDP deflator
if cpi==1
    GDP = GDP_cpi;
    inflation=inf_cpi;
    Wage = Wage_cpi;
else
    GDP = GDP_def;
    inflation=inf_def;
    Wage = Wage_def;
end

period=[5,47;
         48, 84;
         85, 123;
         124, 171;
         124,181];

start=period(1,1);

%% main variables
figure
plot(inflation(period(1,1)-start+1:period(4,2)-start+1)*4)
    hold on
    plot([period(1,1)-start+1,period(1,2)-start+1], [mean(inflation(period(1,1)-start+5:period(1,2)-start+5))*4 mean(inflation(period(1,1)-start+5:period(1,2)-start+5))*4], 'k');
    plot([period(2,1)-start+1,period(2,2)-start+1], [mean(inflation(period(2,1)-start+5:period(2,2)-start+5))*4 mean(inflation(period(2,1)-start+5:period(2,2)-start+5))*4], 'k');
    plot([period(3,1)-start+1,period(3,2)-start+1], [mean(inflation(period(3,1)-start+5:period(3,2)-start+5))*4 mean(inflation(period(3,1)-start+5:period(3,2)-start+5))*4], 'k');
    plot([period(4,1)-start+1,period(4,2)-start+1], [mean(inflation(period(4,1)-start+5:period(4,2)-start+5))*4 mean(inflation(period(4,1)-start+5:period(4,2)-start+5))*4], 'k');
   
    hold off
    title('Inflation rate (annual, %)')

figure
plot(log(share(period(1,1)-start+1:period(4,2)-start+1))*100)
    hold on
    plot([period(1,1)-start+1,period(1,2)-start+1], [mean(log(share(period(1,1)-start+5:period(1,2)-start+5))*100) mean(log(share(period(1,1)-start+5:period(1,2)-start+5)))*100], 'k');
    plot([period(2,1)-start+1,period(2,2)-start+1], [mean(log(share(period(2,1)-start+5:period(2,2)-start+5))*100) mean(log(share(period(2,1)-start+5:period(2,2)-start+5)))*100], 'k');
    plot([period(3,1)-start+1,period(3,2)-start+1], [mean(log(share(period(3,1)-start+5:period(3,2)-start+5))*100) mean(log(share(period(3,1)-start+5:period(3,2)-start+5)))*100], 'k');
    plot([period(4,1)-start+1,period(4,2)-start+1], [mean(log(share(period(4,1)-start+5:period(4,2)-start+5))*100) mean(log(share(period(4,1)-start+5:period(4,2)-start+5)))*100], 'k');   
    hold off
    title('100*ln(unit labor cost)')

figure
plot(Hours(period(1,1)-start+1:period(4,2)-start+1))
    hold on
    plot([period(1,1)-start+1,period(1,2)-start+1], [mean(Hours(period(1,1)-start+5:period(1,2)-start+5)) mean(Hours(period(1,1)-start+5:period(1,2)-start+5))], 'k');
    plot([period(2,1)-start+1,period(2,2)-start+1], [mean(Hours(period(2,1)-start+5:period(2,2)-start+5)) mean(Hours(period(2,1)-start+5:period(2,2)-start+5))], 'k');
    plot([period(3,1)-start+1,period(3,2)-start+1], [mean(Hours(period(3,1)-start+5:period(3,2)-start+5)) mean(Hours(period(3,1)-start+5:period(3,2)-start+5))], 'k');
    plot([period(4,1)-start+1,period(4,2)-start+1], [mean(Hours(period(4,1)-start+5:period(4,2)-start+5)) mean(Hours(period(4,1)-start+5:period(4,2)-start+5))], 'k');   
   
    hold off
    title('100*ln(Hours worked)')
    
figure
plot(TB3M(period(1,1)-start+1:period(4,2)-start+1)*4)
    hold on
    plot([period(1,1)-start+1,period(1,2)-start+1], [mean(TB3M(period(1,1)-start+5:period(1,2)-start+5)*4) mean(TB3M(period(1,1)-start+5:period(1,2)-start+5))*4], 'k');
    plot([period(2,1)-start+1,period(2,2)-start+1], [mean(TB3M(period(2,1)-start+5:period(2,2)-start+5)*4) mean(TB3M(period(2,1)-start+5:period(2,2)-start+5))*4], 'k');
    plot([period(3,1)-start+1,period(3,2)-start+1], [mean(TB3M(period(3,1)-start+5:period(3,2)-start+5)*4) mean(TB3M(period(3,1)-start+5:period(3,2)-start+5))*4], 'k');
    plot([period(4,1)-start+1,period(4,2)-start+1], [mean(TB3M(period(4,1)-start+5:period(4,2)-start+5)*4) mean(TB3M(period(4,1)-start+5:period(4,2)-start+5))*4], 'k');   
  
    hold off
    title('nominal interest rate (3M Treasury Bond, annual rate, %')    

%% other variables

figure('Name', 'GDP and Wage')

subplot(2,1,1)
plot(GDP)
title('ln(GDP)')

subplot(2,1,2)
plot(Wage)
title('ln(Wage)')


% instrumental variables

figure('Name', 'Instrumental variables')
subplot(3,1,1)
plot(share*100)
title('labor share (%)')

subplot(3,1,2)
plot(L_s_Spread)
title('long-short spread (annual, %)')

subplot(3,1,3)
plot(CRBinflation*4)
title('commodity price inflation (annual, %)')

