%% graphs

model_name={'GNKPC' 'NKPC' 'NoKappad' 'NoKappaf' 'CS-GNKPC' 'CS-NKPC' 'CS-GNKPC-NoKappad' 'CS-GNKPC-NoKappaf'}';
name_mat={'\pi' '\xi_p' '\iota_p' '\theta' '\alpha' '\beta' '\kappa' '\gamma_{b}' '\gamma_{f}'}';

%{
param_name={'400logpi' 'lambda' 'omega' 'theta' 'alpha' 'beta' 'kappa' 'gamma_b' };
graph_name={'GNKPC_400logpi' 'NKPC_400logpi' 'OnlyULC_400logpi' 'NoKappaf_400logpi';
            'GNKPC_lambda' 'NKPC_lambda' 'OnlyULC_lambda' 'NoKappaf_lambda';
           'GNKPC_omega','NKPC_omega' 'OnlyULC_omega' 'NoKappaf_omega';
           'GNKPC_kappa' 'NKPC_kappa' 'OnlyULC_kappa' 'NoKappaf_kappa';
          'GNKPC_gamma_b' 'NKPC_gamma_b' 'OnlyULC_gamma_b' 'NoKappaf_gamma_b'};
%}

for mmm=m1:m2

figure('name', char(model_name(mmm)))
num_subplot=1;

para_estim_extended=[para_estim0(3);para_estim0(2);para_estim0(1);para_estim0(4:6);ones(3,1)];
para_estim3=para_estim_extended;
    if mmm==2||mmm==6
        para_estim3(4)=0;
    end
    
if sum(para_estim3) <5
    num_graph = [2,2];
elseif sum(para_estim3) <7
    num_graph = [3,2];
elseif sum(para_estim3) <9
    num_graph = [4,2];
end
    
if tate==0
    num_graph=transpose(num_graph);
end

for pp=1:size(prior_set,1)+3
if para_estim3(pp)==1
    subplot(num_graph(1),num_graph(2),num_subplot)

hold on

for ss=start_estim_period:end_estim_period
    [f x]=ksdensity(for_graph(:,ss,pp,mmm));
%{
if pp~=6
    [f x]=ksdensity(for_graph(:,ss,pp,mmm));
elseif mmm==1||mmm==3||mmm==4
    [f x]=ksdensity(for_graph(:,ss,pp,mmm),0:0.001:0.2);
elseif mmm==2
    [f x]=ksdensity(for_graph(:,ss,pp,mmm),0:0.0001:0.1);
end
%}
    
if ss==1
    plot(x,f,'k-.')
elseif ss==2
    plot(x,f,'r--')
elseif ss==3
    plot(x,f,'b')
elseif ss==4
    plot(x,f,'m--','LineWidth',1.25)
elseif ss==5
    plot(x,f,'g-','LineWidth',1.25)
end


if pp==2||pp==3||pp==5
    xlim([0,1])
elseif pp==1
  if US==1;
    xlim([-1,8])
  elseif US==0
    xlim([-1,10])
  end
elseif pp==6
    xlim([0.9,0.999])
end
%}

end


hold off

title(name_mat(pp))
num_subplot=num_subplot+1;
% if one page
if pp==size(prior_set,1)+3
    leg=legend(char(period_names(1)),char(period_names(2)),char(period_names(3)),char(period_names(4)),char(period_names(5)));
    leg.Location='best';
    leg.FontSize=6;
    legend('boxoff')
end
end



if tate==1
    yokotate='tate';
elseif tate==0
    yokotate='yoko';
end

end

if mmm==1
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_GNKPC',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_GNKPC',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==2
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_NKPC',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_NKPC',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==3
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_noKappad',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_noKappad',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==4
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_noKappaf',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_noKappaf',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==5
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSGNKPC',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSGNKPC',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==6
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSNKPC',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSNKPC',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==7
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSGNKPCnoKappad',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSCNKPCnoKappad',yokotate,'_',num2str(num),'.fig'],'fig')
elseif mmm==8
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSGNKPCnoKappaf',yokotate,'_',num2str(num),'.eps'],'epsc')
    saveas(gcf,[pwd(),'\',today1,'\',today,'graph_CSGNKPCnoKappaf',yokotate,'_',num2str(num),'.fig'],'fig')

end

close
end