%% post analysis
disp('posterior mode')
%paramod

disp(' Posterior mean, median and std error')
[postmeans', postmeds', poststds']
Theta_result=postmeds';


disp('Convergence test')
convergence_test

% plot the posterior densities
scrsz = get(groot,'ScreenSize');
figure(100)
set(figure(100),'Name', 'Posterior densities','Position',[1 scrsz(4)/2 scrsz(3)/1.6 scrsz(4)/4.5])

% omega
subplot(2,3,1)
    if para_estim(1)==1
     [f,x] = ksdensity(para_s(:,1),0:0.01:1);
    else
     [f,x] = ksdensity(para_s(:,1),mean(para_s(:,1))); 
    end
    plot(x,f)
    hold on
    
    if strcmp(dist_name(1),'B')==1
        plot(x,betapdf2(x,para_pri(1,1),para_pri(1,2)),'--');
    end
    %plot(x,gampdf2(1./(1-x)-1,1/(1-para_pri(1,1))-1,para_pri(1,2)));
    title('\omega')
    hold off

% lambda
subplot(2,3,2)
    if para_estim(2)==1
     [f,x] = ksdensity(para_s(:,2),0:0.01:1);
    else
     [f,x] = ksdensity(para_s(:,2),mean(para_s(:,2))); 
    end
    plot(x,f)
    hold on
    if strcmp(dist_name(2),'B')==1
        plot(x,betapdf2(x,para_pri(2,1),para_pri(2,2)),'--');
    end
        title('\lambda')
    hold off  

% trend inflation
subplot(2,3,3)
    if para_estim(3)==1
        if strcmp(dist_name(3),'N')==1
            [f,x] = ksdensity(para_s(:,3),mean(para_s(:,3))-5:0.05:mean(para_s(:,3))+5);
        else
            [f,x] = ksdensity(para_s(:,3));
        end
    else
     [f,x] = ksdensity(para_s(:,3),mean(para_s(:,3))); 
    end
    plot(x,f)
    hold on
    if strcmp(dist_name(3),'N')==1
        plot(x,normpdf(x,  para_pri(3,1)*4,para_pri(3,2)*4),'--');
        xlim([real(mean(para_s(:,3)))-5,mean(real(para_s(:,3)))+5])
    end
    title('400 \pi')
    hold off

% theta
subplot(2,3,4)
    if para_estim(4)==1
     [f,x] = ksdensity(para_s(:,4),3:0.1:20);
    else
     [f,x] = ksdensity(para_s(:,4),mean(para_s(:,5))); 
    end
    plot(x,f)
    hold on
    if strcmp(dist_name(4),'G')==1
        plot(x,(gampdf2(x, para_pri(4,1),para_pri(4,2))),'--');
    end
    title('\theta')
    hold off

% alpha
subplot(2,3,5)
    if para_estim(5)==1
     [f,x] = ksdensity(para_s(:,5),0:0.01:1);
    else
     [f,x] = ksdensity(para_s(:,5),mean(para_s(:,6))); 
    end
    plot(x,f)
    hold on
    if strcmp(dist_name(1),'B')==1
        plot(x,betapdf2(x, para_pri(5,1),para_pri(5,2)),'--');
    end
    title('\alpha')
    hold off

% beta
subplot(2,3,6)
    if para_estim(6)==1
     [f,x] = ksdensity(para_s(:,6),0.985:0.0001:0.994);
    else
     [f,x] = ksdensity(para_s(:,6),mean(para_s(:,7))); 
    end
    plot(x,f)
    hold on
    if strcmp(dist_name(1),'VTG')==1
        plot(x,100*(gampdf2(100*(1./x-1), 100*(1/para_pri(6,1)-1),para_pri(6,2))),'--');
        xlim([0.985,0.995])
    end

    title('\beta')
    hold off    

% for p=1:size(para_s,2)
% if p>4
%     pp=p-1;
% elseif p<4
%     pp=p;
% end
% if not(p==4)
%     subplot(2,3,pp);
%     if para_estim(pp)==1
%      [f,x] = ksdensity(para_s(:,p));
%     else
%      [f,x] = ksdensity(para_s(:,p),mean(para_s(:,p))); 
%     end
%      plot(x,f)
% 
%     if pp==1
%       hold on
%       
%       plot(x,betapdf2(x,para_pri(1,1),para_pri(1,2)));
%       %plot(x,gampdf2(1./(1-x)-1,1/(1-para_pri(1,1))-1,para_pri(1,2)));
%        title('\omega')
%       hold off
%     elseif pp==2
%       hold on
%       plot(x,betapdf2(x,para_pri(2,1),para_pri(2,2)));
%        title('\lambda')
%       hold off  
%      elseif pp==3
%       hold on
%       plot(x,normpdf(x,  para_pri(3,1)*4,para_pri(3,2)*4));
%        title('\pi')
%       hold off
%      elseif pp==4
%       hold on
%       plot(x,(gampdf2(x, para_pri(4,1),para_pri(4,2))));
%        title('\theta')
%       hold off
%      elseif pp==5
%       hold on
%       plot(x,betapdf2(x, para_pri(5,1),para_pri(5,2)));
%        title('\alpha')
%       hold off
%     elseif pp==6
%       hold on
%       plot(x,100*(gampdf2(100*(1./x-1), 100*(1/para_pri(end,1)-1),para_pri(end,2))));
%        title('\beta')
%       hold off
%     
%     end
% end     
% end

disp(' Some Diagnostics ')
disp('------------------')
disp(' ')
fprintf('acceptance ratio:  %3.2f %%\n',ppacc)
disp(' ')
fprintf('violation ratio:  %3.2f %%\n',violation_test)
disp(' ')

save_result_on_excel