
filename=excelfile;

% model
if model==1
    sheetname='GNKPC-ulc';
elseif model==2
    sheetname='NKPC-ulc';  
elseif model==3
    sheetname='GNKPConlyULC';
elseif model==4
    sheetname='NoKappaf';
elseif model==5
    sheetname='CS-GNKPC-ulc';
elseif model==6
    sheetname='GNKPC-wy';
elseif model==7
    sheetname='NKPC-wy';   
elseif model==8
    sheetname='CS-GNKPC-wy';
elseif model==9
    sheetname='NKPC-wy-diff';
end

% sample period
if sample==1
    area_coef='C9:J15';
    area_accept='I16';
    figureposition='L4';
    nameposition='B6';
elseif sample==2
    area_coef='C22:J28';
    area_accept='I29';
    figureposition='L17';
    nameposition='B19';
elseif sample==3
    area_coef='C35:J41';
    area_accept='I42';
    figureposition='L30';
    nameposition='B32';
elseif sample==4
    area_coef='C48:J54';
    area_accept='I55';
    figureposition='L43';
    nameposition='B45';
elseif sample==5
    area_coef='C61:J67';
    area_accept='I68';
    figureposition='L56';
    nameposition='B58';
elseif sample==6
    area_coef='C74:J80';
    area_accept='I81';
    figureposition='L69';
    nameposition='B71';
end

% country
if US==1
    country='US';
elseif US==0
    country='Japan';
end

% cpi or deflator
if cpi==1
    CPIorDEFLATOR='with PCE(US) or CPI(JP) ';
elseif cpi==0
    CPIorDEFLATOR='with GDP deflator';
end

% number of lags for Newy-West optimal weighting matrix
if NWlags>=0
    NW=['Newy-West_',num2str(NWlags),'lags'];
elseif NWlags==-2
    NW='Autoselect. w/ QS kern.';
elseif NWlags==-1
    NW='Autoselect. w/ Bertlett Kern.';
end

% 2-step GMM or CU-GMM
if TSGMM==1
    GMMmethod='2-step GMM';
else
    GMMmethod='continous-updating GMM';
end

for ii=1:size(para_s(1,:),2)
sorted=sort(para_s(:,ii));
CI(ii,1)=sorted(length(sorted)*0.05,1);
CI(ii,2)=sorted(length(sorted)*0.95,1);
end

% denominator
if denominator==0
    denomi_type='standard';
elseif denominator==1
    denomi_type='denominator=1';
elseif denominator==-1
    denomi_type='partial_normalization';
elseif denominator==2
    denomi_type='coef. of pi_t = 1';
end

kappa_prior

coef=[para_pri(1:2,:),                           paramod(1:2), postmeans(1:2)', postmeds(1:2)',poststds(1:2)',CI(1:2,:);
      para_pri(3,:)*4,                           paramod(3),   postmeans(3)',   postmeds(3)',  poststds(3)',  CI(3,:);
     mean(slope_pri(:,1)), std(slope_pri(:,1)),        NaN,    postmeans(7)',   postmeds(7)',  poststds(7)',  CI(7,:);
      para_pri(4:6,:),                         paramod(4:6),postmeans(4:6)', postmeds(4:6)',poststds(4:6)',CI(4:6,:)];
%       para_fix(1),NaN, NaN,         NaN,             NaN,           NaN,           NaN, NaN    ;
%       para_fix(2),NaN, NaN,         NaN,             NaN,           NaN,           NaN, NaN    ;
%       para_fix(3),NaN, NaN,         NaN,             NaN,           NaN,           NaN, NaN    ];

if model==start_estim_model&&sample==start_estim_period
    if excel_output==1
        copyfile('(format)mcmc_results_1.xlsx',filename,'f')
    end
end
if iniWM==1
    matform='EYE';
elseif iniWM==0
    matform='ZZ';
elseif iniWM==-1
    matform='demeanZZ';
end

%sample_period_des
disp([period_name,'...done. Now saving data'])

if excel_output==1
    xlswrite(filename,ppacc,sheetname,area_accept)
    xlswrite(filename,coef,sheetname,area_coef)
    xlswrite(filename,{country;CPIorDEFLATOR;denomi_type;NW;GMMmethod;matform},sheetname,'I1:I6')
    xlswrite(filename,{['IV:',char(IV)]},sheetname,'L2')
    xlswrite(filename,{[today,'mcmc_results_',num2str(num),'.xlsx']},sheetname,'L1');
    xlswrite(filename,{period_name},sheetname,nameposition);
    try
        haritsuke
    catch
    end
else
    close
end